package main;

import java.io.IOException;
import java.io.PipedInputStream;
import java.io.PipedOutputStream;

public class Main {
    
    private PipedInputStream input;
    private PipedOutputStream output;
    
    private Thread source = new Thread(() -> {
        byte buf[] = new byte[5];
        for (int i = 1; i <= 3; i++){
            try {
                output.write(buf, 0, 5);
                Thread.sleep(i * 100);
            } catch (InterruptedException e){
                break;
            } catch (IOException io){
                System.out.println("Source: IO-Error at " + i * 100 + "ms wait time.");
                break;
            }
        }/*
        try {
            output.close();
        } catch (IOException ex){}*/
        System.out.println("Source: terminated");
    });


    private Thread sink = new Thread(() -> {
        byte buf[] = new byte[10];
        int pos = 0;
        int idleCounter = 0;
        while (true){
            try {
                if (input.available() > 0){
                    int len = input.read(buf, pos, 10 - pos);
                    pos += len;
                    if (pos == 10){
                        pos = 0;
                        System.out.println("-> " + len + " bytes received");
                        System.out.println("-> Packet complete");
                    } else {
                        System.out.println("-> " + len + " bytes received");
                    }
                    idleCounter = 0;
                } else if (++idleCounter == 10){
                    System.out.println("Sink:   IDLE -> terminate");
                    break;
                } else {
                    Thread.sleep(50);
                }
            } catch (InterruptedException ex){
                break;
            } catch (IOException io){
                System.out.println("Sink:   " + 100);
                break;
            }
        }
        try {
            input.close();
        } catch (IOException ex){}
        System.out.println("Sink:   terminated");
    });
    
    public Main() throws IOException{
        input = new PipedInputStream();
        output = new PipedOutputStream(input);
        source.start();
        sink.start();
    }

    public static void main(String[] args) throws IOException { new Main(); }
}
